"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const classPool = [];
function injectable(_constructor) {
    let paramsTypes = Reflect.getMetadata('design:paramtypes', _constructor);
    if (classPool.indexOf(_constructor) !== -1) {
        return;
    }
    else if (paramsTypes.length) {
        paramsTypes.forEach((v, i) => {
            if (v === _constructor) {
                throw new Error('不可以依赖自身');
            }
            else if (classPool.indexOf(v) === -1) {
                throw new Error(`依赖${i}[${v.name}]不可被注入`);
            }
        });
    }
    classPool.push(_constructor);
    console.log(classPool);
}
exports.injectable = injectable;
function create(_constructor) {
    let paramsTypes = Reflect.getMetadata('design:paramtypes', _constructor);
    let paramInstances = paramsTypes.map((v, i) => {
        if (classPool.indexOf(v) === -1) {
            throw new Error(`参数${i}[${v.name}]不可被注入`);
        }
        else if (v.length) {
            return create(v);
        }
        else {
            return new v();
        }
    });
    return new _constructor(...paramInstances);
}
exports.create = create;
