"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const widgetfactory_1 = require("./widgets/widgetfactory");
const widgetrender_1 = require("./common/widgetrender");
const inversify_1 = require("inversify");
let DockerDashboard = class DockerDashboard {
    constructor(layout, widgetFactory) {
        this.layout = layout;
        this.widgetFactory = widgetFactory;
    }
    startup() {
        this.layout.setMenu(this.widgetFactory.getCommands());
        this.layout.asDefault(this.widgetFactory.getDefault());
        this.layout.render();
    }
};
DockerDashboard = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject("Setup")), __param(1, inversify_1.inject("WidgetFactory")),
    __metadata("design:paramtypes", [Object, widgetfactory_1.WidgetFactory])
], DockerDashboard);
exports.DockerDashboard = DockerDashboard;
let BoardLayout = class BoardLayout {
    constructor() {
        this.screen = widgetrender_1.WidgetRender.screen("🐳 Docker Dashboard");
        this.screen.key(["q"], () => {
            return process.exit(0);
        });
        this.box = widgetrender_1.WidgetRender.box(this.screen);
    }
    setMenu(commands) {
        widgetrender_1.WidgetRender.menuBar(this.screen, commands);
    }
    asDefault(element) {
        this.activeElement = element;
        this.activeElement.render();
    }
    active(element) {
        this.activeElement.hide();
        this.activeElement = element;
        this.activeElement.show();
        this.screen.render();
    }
    getBox() {
        return this.box;
    }
    getScreen() {
        return this.screen;
    }
    render() {
        this.screen.render();
    }
    onResize(callback) {
        this.screen.on('resize', () => {
            callback();
        });
    }
};
BoardLayout = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [])
], BoardLayout);
exports.BoardLayout = BoardLayout;
