"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const inversify_1 = require("inversify");
const dockerdashboard_1 = require("../dockerdashboard");
const widgetfactory_1 = require("../widgets/widgetfactory");
const homewidget_1 = require("../widgets/homewidget");
const helpwidget_1 = require("../widgets/helpwidget");
const containerwidget_1 = require("../widgets/containerwidget");
const imagewidget_1 = require("../widgets/imagewidget");
const networkwidget_1 = require("../widgets/networkwidget");
const volumewideget_1 = require("../widgets/volumewideget");
const ioc = new inversify_1.Container({ autoBindInjectable: true });
exports.ioc = ioc;
const TYPES = {
    Layout: Symbol.for("Layout")
};
exports.TYPES = TYPES;
ioc.bind("DockerDashboard").to(dockerdashboard_1.DockerDashboard).inSingletonScope();
const boardLayout = new dockerdashboard_1.BoardLayout();
ioc.bind("Layout").toConstantValue(boardLayout);
ioc.bind("Setup").toConstantValue(boardLayout);
ioc.bind("WidgetFactory").to(widgetfactory_1.WidgetFactory).inSingletonScope();
ioc.bind("Widget").to(homewidget_1.HomeWidget);
ioc.bind("Widget").to(containerwidget_1.ContainerWidget);
ioc.bind("Widget").to(imagewidget_1.ImageWidget);
ioc.bind("Widget").to(networkwidget_1.NetworkWidget);
ioc.bind("Widget").to(volumewideget_1.VolumeWidget);
ioc.bind("Widget").to(helpwidget_1.HelpWidget);
