"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const widget_1 = require("./widget");
const widgetrender_1 = require("../common/widgetrender");
const inversify_1 = require("inversify");
let HelpWidget = class HelpWidget extends widget_1.Widget {
    getCommandName() {
        return "Help";
    }
    getCommandKey() {
        return {
            keys: ["h"],
            callback: () => {
                if (!this.helpBox) {
                    this.render();
                }
                this.active();
            }
        };
    }
    getAllElements() {
        return [this.helpBox];
    }
    renderWidget(box) {
        const content = '\n' +
            '   Shortcut\n' +
            '   -----------------------------------------------------------------\n' +
            '   D       :  show node info.\n' +
            '   C       :  show container list.\n' +
            '   I       :  show iamge list.\n' +
            '   N       :  show network.\n' +
            '   V       :  show volume list.\n' +
            '   H       :  show help.\n' +
            '   Q       :  exit.\n' +
            '   \n' +
            '   About\n' +
            '   -----------------------------------------------------------------\n' +
            '   Github  :  https://github.com/pipiliang/docker-dashboard\n' +
            '   Issues  :  https://github.com/pipiliang/docker-dashboard/issues\n' +
            '   Lisence :  MIT\n' +
            '   Thanks  :  \n' +
            '              1. blessed \n' +
            '              2. blessed-contrib \n' +
            '              3. dockerode';
        this.helpBox = widgetrender_1.WidgetRender.helpBox(box, content);
    }
};
HelpWidget = __decorate([
    inversify_1.injectable()
], HelpWidget);
exports.HelpWidget = HelpWidget;
