"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const widget_1 = require("./widget");
const widgetrender_1 = require("../common/widgetrender");
const dockerode_1 = require("../common/docker/dockerode");
const log_1 = require("../common/log");
const inversify_1 = require("inversify");
let ImageWidget = class ImageWidget extends widget_1.Widget {
    constructor() {
        super(...arguments);
        this.selectId = "";
    }
    getCommandName() {
        return "Images";
    }
    getCommandKey() {
        return {
            keys: ["i"],
            callback: () => {
                if (!this.imageTable) {
                    this.render();
                }
                this.active();
            }
        };
    }
    getAllElements() {
        return [this.imageTable, this.layerTable, this.text];
    }
    renderWidget(box) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const location = { top: 0, left: 0, width: "100%-2", height: "40%-2" };
                this.imageTable = widgetrender_1.WidgetRender.table(box, location, "Images");
                const data = yield dockerode_1.Dockerode.singleton.listImages();
                this.imageTable.setData(data);
                this.imageTable.on("select", (item) => {
                    this.selectImage(item);
                });
                this.text = widgetrender_1.WidgetRender.text(box, { top: "40%-2", left: 0, width: "100%-2", height: 2 }, "{bold}✔  Image Infomation{bold}");
                this.layerTable = widgetrender_1.WidgetRender.table(box, { top: "40%", left: 0, width: "100%-2", height: "60%-1" }, "Layers");
                this.layerTable.setData([['Order', 'Size', 'Layer']]);
            }
            catch (error) {
                log_1.Log.error(error);
            }
        });
    }
    selectImage(item) {
        return __awaiter(this, void 0, void 0, function* () {
            const selectId = item.content.substring(0, 12);
            if (this.selectId == selectId) {
                return;
            }
            this.selectId = selectId;
            this.text.setContent("{bold}✔ Image Infomation (" + selectId + "){bold}");
            this.refresh();
            const image = dockerode_1.Dockerode.singleton.getImage(this.selectId);
            const data = yield image.history();
            this.layerTable.setData(data);
        });
    }
};
ImageWidget = __decorate([
    inversify_1.injectable()
], ImageWidget);
exports.ImageWidget = ImageWidget;
